// ChooseCompPage.h: interface for the CChooseCompPage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHOOSECOMPPAGE_H__11AB6BF5_87DD_4D76_9F3B_4042FA2F0CE6__INCLUDED_)
#define AFX_CHOOSECOMPPAGE_H__11AB6BF5_87DD_4D76_9F3B_4042FA2F0CE6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CChooseCompPage : public CSnapInPropertyPageImpl<CChooseCompPage>
{
public:
	CChooseCompPage(long lNotifyHandle, bool bDeleteHandle = true, TCHAR* pTitle = NULL) : 
		CSnapInPropertyPageImpl<CChooseCompPage> (pTitle),
		m_lNotifyHandle(lNotifyHandle),
		m_bDeleteHandle(bDeleteHandle) // Should be true for only page.
	{
	}

	~CChooseCompPage()
	{
		if (m_bDeleteHandle)
			MMCFreeNotifyHandle(m_lNotifyHandle);
	}

	enum { IDD = IDD_PROPPAGE_CHOOSE_MACHINE };

BEGIN_MSG_MAP(CChooseCompPage)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(CSnapInPropertyPageImpl<CChooseCompPage>)
	COMMAND_HANDLER(IDC_CHOOSER_BUTTON_BROWSE_MACHINENAMES, BN_CLICKED, OnClickedChooseMachine)
END_MSG_MAP()
// Handler prototypes:
//	LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//	LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//	LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		USES_CONVERSION;
		ATLASSERT(::IsWindow(m_hWnd));
		ATLASSERT(GetParent() != NULL);
		::PostMessage(GetParent(), PSM_SETWIZBUTTONS, 0, PSWIZB_FINISH);
		return TRUE;
	}

	HRESULT PropertyChangeNotify(long param)
	{
		return MMCPropertyChangeNotify(m_lNotifyHandle, param);
	}
	BOOL OnApply()
	{
		return TRUE;
	}
	BOOL OnWizardFinish()
	{
		return TRUE;
	}

	LRESULT OnClickedChooseMachine(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

private:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;
};

#endif // !defined(AFX_CHOOSECOMPPAGE_H__11AB6BF5_87DD_4D76_9F3B_4042FA2F0CE6__INCLUDED_)
