// MsgViewNode1.cpp: implementation of the CMsgViewNode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MsgViewNode1.h"

static const GUID CMsgViewNodeGUID_NODETYPE = 
{ 0xe65867c2, 0x7e9, 0x4fab, { 0xac, 0x6f, 0xb5, 0x6, 0xe2, 0xea, 0x1f, 0x4b } };
const GUID*  CMsgViewNode::m_NODETYPE = &CMsgViewNodeGUID_NODETYPE;
const OLECHAR* CMsgViewNode::m_SZNODETYPE = OLESTR("E65867C2-07E9-4fab-AC6F-B506E2EA1F4B");
const OLECHAR* CMsgViewNode::m_SZDISPLAY_NAME = OLESTR("Message View");
const CLSID* CMsgViewNode::m_SNAPIN_CLASSID = &CLSID_Simple;

HRESULT CMsgViewNode::OnSelect(IConsole *spConsole, IComponent* pComponent)
{
	IToolbar* p = (IToolbar*) ((CSimpleComponent*)pComponent)->m_toolbarMap.Lookup(IDR_TOOLBAR_MSGNODE);
	if(p)
		p->SetButtonState(ID_BUTTON32774, ENABLED, FALSE);
	
	return S_OK;
}

//this function can be used either for result or scope items, by checking the m_nType
HRESULT CMsgViewNode::InvokeWizzard(bool& bHandled, CSnapInObjectRootBase* pObj)
{
	CComPtr<IUnknown> pUnk;
	HRESULT hr = CoCreateInstance(CLSID_NodeManager, NULL,CLSCTX_INPROC_SERVER,IID_IPropertySheetProvider, (void**)&pUnk);
	if (FAILED(hr))
	    return S_FALSE;    
	CComQIPtr<IPropertySheetProvider,&IID_IPropertySheetProvider> spPSProvider(pUnk);
	CComPtr<IDataObject> spDataObject;
	hr = GetDataObject(&spDataObject, CCT_SCOPE);
	if (FAILED(hr))
	    return S_FALSE;    
	hr = spPSProvider->CreatePropertySheet(L"Property", FALSE, (long)this, spDataObject,MMC_PSO_NEWWIZARDTYPE);
	if (FAILED(hr))
	    return hr;
	_ASSERTE(pObj != NULL && (pObj->m_nType == 1 || pObj->m_nType == 2));
	HWND hWnd=NULL;

	if (pObj->m_nType == 2) // Result Pane
	{
		IComponent* pComponent;
		hr = ((CSimpleComponent*)pObj)->QueryInterface(IID_IComponent, (void**)&pComponent);
		spPSProvider->AddPrimaryPages(pComponent, TRUE, NULL, FALSE);
		if(pComponent != NULL)
			pComponent->Release();

		((CSimpleComponent*)pObj)->m_spConsole->GetMainWindow(&hWnd);
	}
	else	//scope pane
	{
		IComponentData* pComponentData;
		hr = ((CSimple*)pObj)->QueryInterface(IID_IComponentData, (void**)&pComponentData);
		spPSProvider->AddPrimaryPages(pComponentData, TRUE, NULL, FALSE);
		if(pComponentData != NULL)
			pComponentData->Release();
		((CSimple*)pObj)->m_spConsole->GetMainWindow(&hWnd);
	}
	hr = spPSProvider->Show((long)hWnd,0);
	if (hr == S_FALSE) // recover from a failed Show
	{
			spPSProvider->Show(-1,0); // frees wizard resources
										// held by MMC
			return S_FALSE;
	}

return hr;
}
