// MsgViewNode1.h: interface for the CMsgViewNode class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSGVIEWNODE1_H__F48A0ADB_E6ED_45C9_A786_376EFF6FFD91__INCLUDED_)
#define AFX_MSGVIEWNODE1_H__F48A0ADB_E6ED_45C9_A786_376EFF6FFD91__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMsgViewNode : public CBaseNodeItem<CMsgViewNode>  
{
public:

	CMsgViewNode()
	{
		memset(&m_scopeDataItem, 0, sizeof(SCOPEDATAITEM));
		m_scopeDataItem.mask = SDI_STR | SDI_IMAGE | SDI_OPENIMAGE | SDI_PARAM | SDI_CHILDREN;
		m_scopeDataItem.displayname = MMC_CALLBACK;
		m_scopeDataItem.nImage = 0; 		
		m_scopeDataItem.nOpenImage = 1;
		m_scopeDataItem.lParam = (LPARAM) this;
		memset(&m_resultDataItem, 0, sizeof(RESULTDATAITEM));
	}

	BEGIN_SNAPINTOOLBARID_MAP(CMsgViewNode)
		// Create toolbar resources with button dimensions 16x16 
		// and add an entry to the MAP. You can add multiple toolbars
		SNAPINTOOLBARID_ENTRY(IDR_TOOLBAR_MSGNODE)
	END_SNAPINTOOLBARID_MAP()

	SNAPINMENUID(IDR_SIMPLE_MENU);

	BEGIN_SNAPINCOMMAND_MAP(CNodeB, FALSE)
		SNAPINCOMMAND_ENTRY(ID_TASK_WIZARD, InvokeWizzard)
		SNAPINCOMMAND_ENTRY(ID_BUTTON32773, ToolBarClicked)
	END_SNAPINCOMMAND_MAP()
	
	HRESULT ToolBarClicked(bool& bHandled, CSnapInObjectRootBase* pObj)
	{
		bHandled= true;
		return S_OK;
	}

	HRESULT OnSelect(IConsole *spConsole, IComponent* pComponent);
	HRESULT InvokeWizzard(bool& bHandled, CSnapInObjectRootBase* pObj);

	STDMETHOD(CreatePropertyPages)(LPPROPERTYSHEETCALLBACK lpProvider,long handle, IUnknown* pUnk,
							DATA_OBJECT_TYPES type)
	{
		if (type == CCT_SCOPE || type == CCT_RESULT)
		{
			// The second parameter  to the property page class constructor
			// should be true for only one page.
			CSimpleWizPage1* pPage = new CSimpleWizPage1(handle, false, _T("Simple"));
			CSimpleWizPage2* pPage2 = new CSimpleWizPage2(handle, false, _T("Simple"));
			HRESULT hr = lpProvider->AddPage(pPage->Create());
			if(FAILED(hr))
				return E_FAIL;

			hr = lpProvider->AddPage(pPage2->Create());
			if(FAILED(hr))
				return E_FAIL;
			return S_OK;
		}
		return E_UNEXPECTED;
	}

	STDMETHOD(QueryPagesFor)(DATA_OBJECT_TYPES type)
	{
		if (type == CCT_SCOPE || type == CCT_RESULT)
			return S_OK;
		return S_FALSE;
	}

	HRESULT OnShowContextHelp(IDisplayHelp *pDisplayHelp)
	{
		USES_CONVERSION;	
		LPOLESTR pszTopic = static_cast<LPOLESTR>(CoTaskMemAlloc(MAX_PATH * sizeof(WCHAR)));
		ocscpy(pszTopic , T2OLE("simpsnap.chm::/main_page.htm"));
		return pDisplayHelp->ShowTopic(pszTopic);
	}

	HRESULT OnShow(IConsole *pConsole, BOOL bShow)
	{
		//CComQIPtr<IResultData, &IID_IResultData> spResultData(spConsole);
		HRESULT hr;
		IUnknown *pUnk = NULL;
		IMessageView *pMessageView = NULL;
		hr = pConsole->QueryResultView(&pUnk);
		if (SUCCEEDED(hr)) 
		{
			hr = pUnk->QueryInterface(IID_IMessageView, (void **)&pMessageView);
			if (SUCCEEDED(hr)) 
			{
				pMessageView->SetIcon(Icon_Information);
				pMessageView->SetTitleText(L"MessageView");
				pMessageView->SetBodyText(L"This Folder has no child nodes.");
				pMessageView->Release();
			}
			pUnk->Release();
		}

		return S_FALSE;
	}

	STDMETHOD(GetResultViewType)(LPOLESTR *ppViewType,long *pViewOptions)
	{
		LPOLESTR lpOleStr = NULL;
		HRESULT hr = StringFromCLSID(CLSID_MessageView, &lpOleStr);
		if(SUCCEEDED(hr))
			*ppViewType = lpOleStr;
		else 
			*ppViewType = NULL;

		*pViewOptions = MMC_VIEW_OPTIONS_NONE;
		return S_FALSE;
	}

	LPOLESTR GetResultPaneColInfo(int nCol)
	{
	   switch (nCol)
	   {
	   case 0:
		  return m_bstrDisplayName;
	   case 1:
		  return OLESTR("Column Y");
	   }

	   return OLESTR("Override GetResultPaneColInfo");
	}

};

#endif // !defined(AFX_MSGVIEWNODE1_H__F48A0ADB_E6ED_45C9_A786_376EFF6FFD91__INCLUDED_)
