// PropPages.h: interface for the PropPages class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROPPAGES_H__308FA1C3_02D9_44B3_A41C_0560D36D5FB9__INCLUDED_)
#define AFX_PROPPAGES_H__308FA1C3_02D9_44B3_A41C_0560D36D5FB9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
class CSimpNode;

class CSimplePage : public CSnapInPropertyPageImpl<CSimplePage>
{
public :

	CSimplePage(CSimpNode* pParent, long lNotifyHandle, bool bDeleteHandle = false, TCHAR* pTitle = NULL) : 
		CSnapInPropertyPageImpl<CSimplePage> (pTitle),
		m_lNotifyHandle(lNotifyHandle),
		m_bDeleteHandle(bDeleteHandle), // Should be true for only page.
		m_pParent(pParent)
	{
	}

	~CSimplePage()
	{
		if (m_bDeleteHandle)
			MMCFreeNotifyHandle(m_lNotifyHandle);
	}

	enum { IDD = IDD_SIMPLE };

BEGIN_MSG_MAP(CSimplePage)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(CSnapInPropertyPageImpl<CSimplePage>)
END_MSG_MAP()
// Handler prototypes:
//	LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//	LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//	LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	HRESULT PropertyChangeNotify(long param)
	{
		return MMCPropertyChangeNotify(m_lNotifyHandle, param);
	}
	
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		SetDlgItemText(IDC_SOMETEXT,_T("That's All There is to it!"));
		return TRUE;
	}
	BOOL OnApply()
	{
		//m_pParent-> set the members or something
		PropertyChangeNotify(0); //do something usefull. the msg will end up in Notify of CSimple
		return TRUE;
	}

public:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;
	CSimpNode* m_pParent;
};

#endif // !defined(AFX_PROPPAGES_H__308FA1C3_02D9_44B3_A41C_0560D36D5FB9__INCLUDED_)
