#include "stdafx.h"
#include "MMCSnap.h"
#include "Simple.h"

/////////////////////////////////////////////////////////////////////////////
// CSimpleComponentData
static const GUID CSimpleGUID_NODETYPE = 
{ 0x813a64f9, 0xec5e, 0x4a73, { 0x90, 0x72, 0xcc, 0x36, 0x67, 0xd1, 0xc4, 0xf } };
const GUID*  CSimpleData::m_NODETYPE = &CSimpleGUID_NODETYPE;
const OLECHAR* CSimpleData::m_SZNODETYPE = OLESTR("813A64F9-EC5E-4A73-9072-CC3667D1C40F");
const OLECHAR* CSimpleData::m_SZDISPLAY_NAME = OLESTR("Simple");
const CLSID* CSimpleData::m_SNAPIN_CLASSID = &CLSID_Simple;

HRESULT CSimpleData::OnExpand(BOOL bExpand, IConsole *pConsole, HSCOPEITEM parent)
{
	if (!bExpand)
	   return S_OK;

	m_scopeDataItem.ID = parent;
	HSCOPEITEM hChild = NULL;
	long cookie = 0;
	CComQIPtr<IConsoleNameSpace, &IID_IConsoleNameSpace> spConsoleNameSpace(pConsole);
	spConsoleNameSpace->GetChildItem(m_scopeDataItem.ID, &hChild, &cookie);
	if (hChild != NULL)
	  spConsoleNameSpace->DeleteItem(m_scopeDataItem.ID, FALSE);

	m_pSimpNode->m_scopeDataItem.relativeID = m_scopeDataItem.ID;
	HRESULT hr = spConsoleNameSpace->InsertItem(&m_pSimpNode->m_scopeDataItem);
	_ASSERT( SUCCEEDED(hr) );
	
	m_pMsgNode->m_scopeDataItem.relativeID = m_scopeDataItem.ID;
	hr = spConsoleNameSpace->InsertItem(&m_pMsgNode->m_scopeDataItem);
	_ASSERT( SUCCEEDED(hr) );

	m_pAxNode->m_scopeDataItem.relativeID = m_scopeDataItem.ID;
	hr = spConsoleNameSpace->InsertItem(&m_pAxNode->m_scopeDataItem);
	_ASSERT( SUCCEEDED(hr) );
	return S_OK;
//after this MMC calls GetDisplayInfo() which 
//in ATL translates to GetScopePaneInfo()
}

HRESULT STDMETHODCALLTYPE CSimple::GetHelpTopic(/* [out] */ LPOLESTR __RPC_FAR *lpCompiledHelpFile)
{
	USES_CONVERSION;	
	if ( !lpCompiledHelpFile)
		return E_POINTER; // invalid argument 
	*lpCompiledHelpFile = (LPOLESTR) CoTaskMemAlloc( MAX_PATH * sizeof(WCHAR) ); 
	if ( !lpCompiledHelpFile )
		return E_OUTOFMEMORY;
	
	#pragma chMSG(Change the help path to valid path)
	ocscpy(*lpCompiledHelpFile, T2OLE("Help\\simpsnap.chm"));
	return S_OK;
}

HRESULT CSimple::Initialize(LPUNKNOWN pUnknown)
{
	HRESULT hr = IComponentDataImpl<CSimple, CSimpleComponent >::Initialize(pUnknown);
	if (FAILED(hr))
		return hr;

	CComPtr<IImageList> spImageList;

	if (m_spConsole->QueryScopeImageList(&spImageList) != S_OK)
	{
		ATLTRACE(_T("IConsole::QueryScopeImageList failed\n"));
		return E_UNEXPECTED;
	}
	// Load bitmaps associated with the scope pane
	// and add them to the image list
	// Loads the default bitmaps generated by the wizard
	// Change as required
	return LoadImages(spImageList);
}

HRESULT CSimple::LoadImages(IImageList* pImageList)
{
	HRESULT hr = E_FAIL;
	HBITMAP m_hSmallBmp = LoadBitmap(_Module.GetResourceInstance(),MAKEINTRESOURCE(IDR_SMICONS));
	   if (m_hSmallBmp != NULL)
	   {
		  HBITMAP m_hLargeBmp = LoadBitmap(_Module.GetResourceInstance(),MAKEINTRESOURCE(IDR_LGICONS));
		  if (m_hLargeBmp != NULL)
		  {
			 hr = pImageList->ImageListSetStrip((long*) m_hSmallBmp, (long*) m_hLargeBmp,0, RGB(0, 128, 128));
			 if (FAILED(hr))
				ATLTRACE(_T("IImageList::ImageListSetStrip failed\n"));
		  }
		  DeleteObject(m_hLargeBmp);
	   }
	  DeleteObject(m_hSmallBmp);
	 return hr;
}