// SimpleWizPage1.h: interface for the CSimpleWizPage1 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SIMPLEWIZPAGE1_H__666A69BC_2B3A_4A24_BB75_4E45598C88BE__INCLUDED_)
#define AFX_SIMPLEWIZPAGE1_H__666A69BC_2B3A_4A24_BB75_4E45598C88BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSimpleWizPage1 : public CSnapInPropertyPageImpl<CSimpleWizPage1>  
{
public:
	CSimpleWizPage1(long lNotifyHandle, bool bDeleteHandle = false, TCHAR* pTitle = NULL) : 
		CSnapInPropertyPageImpl<CSimpleWizPage1> (pTitle),
		m_lNotifyHandle(lNotifyHandle),
		m_bDeleteHandle(bDeleteHandle) // Should be true for only page.
	{
	}

	~CSimpleWizPage1()
	{
		if (m_bDeleteHandle)
			MMCFreeNotifyHandle(m_lNotifyHandle);
	}

	enum { IDD = IDD_PROPPAGE_FIRST };

BEGIN_MSG_MAP(CSimpleWizPage1)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(CSnapInPropertyPageImpl<CSimpleWizPage1>)
END_MSG_MAP()
// Handler prototypes:
//	LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//	LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//	LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	HRESULT PropertyChangeNotify(long param)
	{
		return MMCPropertyChangeNotify(m_lNotifyHandle, param);
	}
	
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		SetDlgItemText(IDC_SOMETEXT,_T("That's All There is to it!"));
		ATLASSERT(::IsWindow(m_hWnd));
		ATLASSERT(GetParent() != NULL);
		SendMessage(GetParent(), PSM_SETWIZBUTTONS, 0, PSWIZB_NEXT);
		return TRUE;
	}
	BOOL OnApply()
	{
		return TRUE;
	}
	BOOL OnWizardNext()
	{
		ATLASSERT(::IsWindow(m_hWnd));
		ATLASSERT(GetParent() != NULL);
		::PostMessage(GetParent(), PSM_SETWIZBUTTONS, 0, PSWIZB_FINISH);
		return TRUE;
	}

public:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;
};


class CSimpleWizPage2 : public CSnapInPropertyPageImpl<CSimpleWizPage2>
{
public:

	CSimpleWizPage2(long lNotifyHandle, bool bDeleteHandle = false, TCHAR* pTitle = NULL) : 
		CSnapInPropertyPageImpl<CSimpleWizPage2> (pTitle),
		m_lNotifyHandle(lNotifyHandle),
		m_bDeleteHandle(bDeleteHandle) // Should be true for only page.
	{
	}

	~CSimpleWizPage2()
	{
		if (m_bDeleteHandle)
			MMCFreeNotifyHandle(m_lNotifyHandle);
	}

	enum { IDD = IDD_PROPPAGE_LAST };

BEGIN_MSG_MAP(CSimpleWizPage2)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(CSnapInPropertyPageImpl<CSimpleWizPage2>)
END_MSG_MAP()
// Handler prototypes:
//	LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//	LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//	LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	BOOL OnWizardBack()
	{
		::PostMessage(GetParent(), PSM_SETWIZBUTTONS, 0, PSWIZB_NEXT);
		return TRUE;
	}
	BOOL OnWizardFinish()
	{
		return TRUE;
	}
	HRESULT PropertyChangeNotify(long param)
	{
		return MMCPropertyChangeNotify(m_lNotifyHandle, param);
	}
	
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		SetDlgItemText(IDC_SOMETEXT,_T("That's All There is to it!"));
		return TRUE;
	}
	BOOL OnApply()
	{
		return TRUE;
	}

public:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;
};


#endif // !defined(AFX_SIMPLEWIZPAGE1_H__666A69BC_2B3A_4A24_BB75_4E45598C88BE__INCLUDED_)
